# coding: utf-8

"""
    Song API

    Song API reference for developers. SONG is an open source system for validating and tracking metadata about raw data submissions, assigning identifiers to entities of interest, and managing the state of the raw data with regards to publication and access  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from overture_song.api_client import ApiClient


class ExportApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def export_analyses(self, analysis_ids, **kwargs):  # noqa: E501
        """ExportAnalyses  # noqa: E501

        Exports the payload for a list of analysisIds  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.export_analyses(analysis_ids, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str analysis_ids: Comma separated list of analysisIds (required)
        :return: list[ExportedPayload]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.export_analyses_with_http_info(analysis_ids, **kwargs)  # noqa: E501
        else:
            (data) = self.export_analyses_with_http_info(analysis_ids, **kwargs)  # noqa: E501
            return data

    def export_analyses_with_http_info(self, analysis_ids, **kwargs):  # noqa: E501
        """ExportAnalyses  # noqa: E501

        Exports the payload for a list of analysisIds  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.export_analyses_with_http_info(analysis_ids, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str analysis_ids: Comma separated list of analysisIds (required)
        :return: list[ExportedPayload]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['analysis_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method export_analyses" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'analysis_ids' is set
        if ('analysis_ids' not in params or
                params['analysis_ids'] is None):
            raise ValueError("Missing the required parameter `analysis_ids` when calling `export_analyses`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'analysis_ids' in params:
            path_params['analysisIds'] = params['analysis_ids']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/export/analysis/{analysisIds}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ExportedPayload]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def export_study(self, study_id, **kwargs):  # noqa: E501
        """ExportStudy  # noqa: E501

        Exports all the payloads for a study  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.export_study(study_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str study_id: studyId (required)
        :return: list[ExportedPayload]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.export_study_with_http_info(study_id, **kwargs)  # noqa: E501
        else:
            (data) = self.export_study_with_http_info(study_id, **kwargs)  # noqa: E501
            return data

    def export_study_with_http_info(self, study_id, **kwargs):  # noqa: E501
        """ExportStudy  # noqa: E501

        Exports all the payloads for a study  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.export_study_with_http_info(study_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str study_id: studyId (required)
        :return: list[ExportedPayload]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['study_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method export_study" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'study_id' is set
        if ('study_id' not in params or
                params['study_id'] is None):
            raise ValueError("Missing the required parameter `study_id` when calling `export_study`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'study_id' in params:
            path_params['studyId'] = params['study_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/export/studies/{studyId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ExportedPayload]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
